diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/tests/test-ns3.py ns-3.41/utils/tests/test-ns3.py
--- ns-3.40/utils/tests/test-ns3.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/tests/test-ns3.py	2024-02-09 14:44:08.633795300 -0800
@@ -3098,7 +3364,8 @@
         @return None
         """
         return_code, stdout, stderr = run_ns3(
-            "configure --enable-tests --enable-examples --enable-sanitizers -d optimized")
+            "configure --enable-tests --enable-examples --enable-sanitizers -d optimized"
+        )
         self.assertEqual(return_code, 0)
 
         test_return_code, stdout, stderr = run_program("test.py", "", python=True)
@@ -3123,18 +3390,22 @@
             images += list(Path("./doc").glob("**/figures/**/*.{ext}".format(ext=extension)))
 
         # Get the brightness of an image on a scale of 0-100%
-        imagemagick_get_image_brightness = \
-            'convert {image} -colorspace HSI -channel b -separate +channel -scale 1x1 -format "%[fx:100*u]" info:'
+        imagemagick_get_image_brightness = 'convert {image} -colorspace HSI -channel b -separate +channel -scale 1x1 -format "%[fx:100*u]" info:'
 
         # We could invert colors of target image to increase its brightness
         # convert source.png -channel RGB -negate target.png
         brightness_threshold = 50
         for image in images:
-            brightness = subprocess.check_output(imagemagick_get_image_brightness.format(image=image).split())
+            brightness = subprocess.check_output(
+                imagemagick_get_image_brightness.format(image=image).split()
+            )
             brightness = float(brightness.decode().strip("'\""))
-            self.assertGreater(brightness, brightness_threshold,
-                               "Image darker than threshold (%d < %d): %s" % (brightness, brightness_threshold, image)
-                               )
+            self.assertGreater(
+                brightness,
+                brightness_threshold,
+                "Image darker than threshold (%d < %d): %s"
+                % (brightness, brightness_threshold, image),
+            )
 
 
 def main():
@@ -3144,45 +3415,41 @@
     """
 
     test_completeness = {
-        "style": [NS3UnusedSourcesTestCase,
-                  NS3StyleTestCase,
-                  ],
-        "build": [NS3CommonSettingsTestCase,
-                  NS3ConfigureBuildProfileTestCase,
-                  NS3ConfigureTestCase,
-                  NS3BuildBaseTestCase,
-                  NS3ExpectedUseTestCase,
-                  ],
-        "complete": [NS3UnusedSourcesTestCase,
-                     NS3StyleTestCase,
-                     NS3CommonSettingsTestCase,
-                     NS3ConfigureBuildProfileTestCase,
-                     NS3ConfigureTestCase,
-                     NS3BuildBaseTestCase,
-                     NS3ExpectedUseTestCase,
-                     NS3QualityControlTestCase,
-                     ],
-        "extras": [NS3DependenciesTestCase,
-                   ]
+        "style": [
+            NS3UnusedSourcesTestCase,
+            NS3StyleTestCase,
+        ],
+        "build": [
+            NS3CommonSettingsTestCase,
+            NS3ConfigureBuildProfileTestCase,
+            NS3ConfigureTestCase,
+            NS3BuildBaseTestCase,
+            NS3ExpectedUseTestCase,
+        ],
+        "complete": [
+            NS3UnusedSourcesTestCase,
+            NS3StyleTestCase,
+            NS3CommonSettingsTestCase,
+            NS3ConfigureBuildProfileTestCase,
+            NS3ConfigureTestCase,
+            NS3BuildBaseTestCase,
+            NS3ExpectedUseTestCase,
+            NS3QualityControlTestCase,
+        ],
+        "extras": [
+            NS3DependenciesTestCase,
+        ],
     }
 
     import argparse
 
     parser = argparse.ArgumentParser("Test suite for the ns-3 buildsystem")
-    parser.add_argument("-c", "--completeness",
-                        choices=test_completeness.keys(),
-                        default="complete")
-    parser.add_argument("-tn", "--test-name",
-                        action="store",
-                        default=None,
-                        type=str)
-    parser.add_argument("-rtn", "--resume-from-test-name",
-                        action="store",
-                        default=None,
-                        type=str)
-    parser.add_argument("-q", "--quiet",
-                        action="store_true",
-                        default=False)
+    parser.add_argument(
+        "-c", "--completeness", choices=test_completeness.keys(), default="complete"
+    )
+    parser.add_argument("-tn", "--test-name", action="store", default=None, type=str)
+    parser.add_argument("-rtn", "--resume-from-test-name", action="store", default=None, type=str)
+    parser.add_argument("-q", "--quiet", action="store_true", default=False)
     args = parser.parse_args(sys.argv[1:])
 
     loader = unittest.TestLoader()
@@ -3226,5 +3493,5 @@
         shutil.move(ns3rc_script_bak, ns3rc_script)
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     main()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/tests/test-test.py ns-3.41/utils/tests/test-test.py
--- ns-3.40/utils/tests/test-test.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/tests/test-test.py	2024-02-09 14:44:08.633795300 -0800
@@ -61,61 +61,67 @@
 #                         write detailed test results into XML-FILE.xml
 
 
-
 from __future__ import print_function
-from TestBase import TestBaseClass
+
 import sys
 
+from TestBase import TestBaseClass
+
+
 def main(argv):
     """
-        Prepares test cases and executes
+    Prepares test cases and executes
     """
     test_cases = [
-        '',
-        '-h',
-        '--help',
-        '-b build/',
-        '--buildpath=build/',
-        '-c performance',
-        '--constrain=performance',
-        '-d',
-        '--duration',
-        '-e socket-options-ipv6',
-        '--example=socket-options-ipv6',
-        '-u',
-        '--update-data',
-        '-f EXTENSIVE',
-        '--fullness=EXTENSIVE',
-        '-g',
-        '--grind',
-        '-l',
-        '--list',
-        '-m',
-        '--multiple',
-        '-n',
-        '--no-build',
-        '-p first',
-        '--pyexample=first',
-        '-r',
-        '--retain',
-        '-s ns3-tcp-state',
-        '--suite=ns3-tcp-state',
-        '-t t_opt.txt',
-        '--text=t_opt.txt && rm t_opt.txt',
-        '-v',
-        '--verbose',
-        '-w t_opt.html && rm t_opt.html',
-        '--web=t_opt.html && rm t_opt.html',
-        '--html=t_opt.html && rm t_opt.html',
-        '-x t_opt.xml && rm t_opt.xml',
-        '--xml=t_opt.xml && rm t_opt.xml',
+        "",
+        "-h",
+        "--help",
+        "-b build/",
+        "--buildpath=build/",
+        "-c performance",
+        "--constrain=performance",
+        "-d",
+        "--duration",
+        "-e socket-options-ipv6",
+        "--example=socket-options-ipv6",
+        "-u",
+        "--update-data",
+        "-f EXTENSIVE",
+        "--fullness=EXTENSIVE",
+        "-g",
+        "--grind",
+        "-l",
+        "--list",
+        "-m",
+        "--multiple",
+        "-n",
+        "--no-build",
+        "-p first",
+        "--pyexample=first",
+        "-r",
+        "--retain",
+        "-s ns3-tcp-state",
+        "--suite=ns3-tcp-state",
+        "-t t_opt.txt",
+        "--text=t_opt.txt && rm t_opt.txt",
+        "-v",
+        "--verbose",
+        "-w t_opt.html && rm t_opt.html",
+        "--web=t_opt.html && rm t_opt.html",
+        "--html=t_opt.html && rm t_opt.html",
+        "-x t_opt.xml && rm t_opt.xml",
+        "--xml=t_opt.xml && rm t_opt.xml",
     ]
 
-    configure_string = sys.executable + ' ns3 configure --enable-tests --enable-examples'
-    clean_string = sys.executable + ' ns3 clean'
-    cmd_execute_list = ['%s && %s test.py %s && %s' % (configure_string, sys.executable, option, clean_string) for option in test_cases]
-    runner = TestBaseClass(argv[1:], "Test suite for the ns-3 unit test runner", 'test-py')
+    configure_string = sys.executable + " ns3 configure --enable-tests --enable-examples"
+    clean_string = sys.executable + " ns3 clean"
+    cmd_execute_list = [
+        "%s && %s test.py %s && %s" % (configure_string, sys.executable, option, clean_string)
+        for option in test_cases
+    ]
+    runner = TestBaseClass(argv[1:], "Test suite for the ns-3 unit test runner", "test-py")
     return runner.runtests(cmd_execute_list)
 
-if __name__ == '__main__':
+
+if __name__ == "__main__":
     sys.exit(main(sys.argv))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils.py ns-3.41/utils.py
--- ns-3.40/utils.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils.py	2024-02-09 14:44:08.629795300 -0800
@@ -8,79 +8,72 @@
 
 
 def get_list_from_file(file_path, list_name):
-    '''Looks for a Python list called list_name in the file specified
+    """Looks for a Python list called list_name in the file specified
     by file_path and returns it.
 
     If the file or list name aren't found, this function will return
     an empty list.
 
-    '''
-
-    list = []
+    """
 
     # Read in the file if it exists.
-    if os.path.exists(file_path):
-        with open(file_path, "r", encoding="utf-8") as file_in:
+    if not os.path.exists(file_path):
+        return []
 
-            # Look for the list.
-            list_string = ""
-            parsing_multiline_list = False
-            for line in file_in:
-
-                # Remove any comments.
-                if '#' in line:
-                    (line, comment) = line.split('#', 1)
-
-                # Parse the line.
-                if list_name in line or parsing_multiline_list:
-                    list_string += line
-
-                    # Handle multiline lists.
-                    if ']' not in list_string:
-                        parsing_multiline_list = True
-                    else:
-                        # Evaluate the list once its end is reached.
-                        # Make the split function only split it once.
-                        list = eval(list_string.split('=', 1)[1].strip())
-                        break
+    with open(file_path, "r", encoding="utf-8") as file_in:
+        # Look for the list.
+        list_string = ""
+        parsing_multiline_list = False
+        for line in file_in:
+            # Remove any comments.
+            if "#" in line:
+                (line, comment) = line.split("#", 1)
+
+            # Parse the line.
+            if list_name in line or parsing_multiline_list:
+                list_string += line
+
+                # Handle multiline lists.
+                if "]" not in list_string:
+                    parsing_multiline_list = True
+                else:
+                    # Evaluate the list once its end is reached.
+                    # Make the split function only split it once.
+                    return eval(list_string.split("=", 1)[1].strip())
 
-    return list
+    # List name was not found
+    return []
 
 
 def get_bool_from_file(file_path, bool_name, value_if_missing):
-    '''Looks for a Python boolean variable called bool_name in the
+    """Looks for a Python boolean variable called bool_name in the
     file specified by file_path and returns its value.
 
     If the file or boolean variable aren't found, this function will
     return value_if_missing.
 
-    '''
+    """
 
     # Read in the file if it exists.
-    if os.path.exists(file_path):
-        with open(file_path, "r", encoding="utf-8") as file_in:
-
-            # Look for the boolean variable.
-            bool_found = False
-            for line in file_in:
-
-                # Remove any comments.
-                if '#' in line:
-                    (line, comment) = line.split('#', 1)
-
-                # Parse the line.
-                if bool_name in line:
-                    # Evaluate the variable's line once it is found.  Make
-                    # the split function only split it once.
-                    bool = eval(line.split('=', 1)[1].strip())
-                    bool_found = True
-                    break
-
-    if bool_found:
-        return bool
-    else:
+    if not os.path.exists(file_path):
         return value_if_missing
 
+    with open(file_path, "r", encoding="utf-8") as file_in:
+        # Look for the boolean variable.
+        for line in file_in:
+            # Remove any comments.
+            if "#" in line:
+                (line, comment) = line.split("#", 1)
+
+            # Parse the line.
+            if bool_name in line:
+                # Evaluate the variable's line once it is found.  Make
+                # the split function only split it once.
+                return eval(line.split("=", 1)[1].strip())
+
+    # Boolean variable was not found
+    return value_if_missing
+
 
 # Reads the NS-3 configuration file and returns a list of enabled modules.
 #
@@ -89,17 +82,17 @@
 def read_config_file():
     # By default, all modules will be enabled, examples will be disabled,
     # and tests will be disabled.
-    modules_enabled  = ['all_modules']
+    modules_enabled = ["all_modules"]
     examples_enabled = False
-    tests_enabled    = False
+    tests_enabled = False
 
     # See if the ns3 configuration file exists in the current working
     # directory and then look for it in the ~ directory.
     config_file_exists = False
-    dot_ns3rc_name = '.ns3rc'
+    dot_ns3rc_name = ".ns3rc"
     dot_ns3rc_path = dot_ns3rc_name
     if not os.path.exists(dot_ns3rc_path):
-        dot_ns3rc_path = os.path.expanduser('~/') + dot_ns3rc_name
+        dot_ns3rc_path = os.path.expanduser("~/") + dot_ns3rc_name
         if not os.path.exists(dot_ns3rc_path):
             # Return all of the default values if the .ns3rc file can't be found.
             return (config_file_exists, modules_enabled, examples_enabled, tests_enabled)
@@ -107,17 +100,17 @@
     config_file_exists = True
 
     # Read in the enabled modules.
-    modules_enabled = get_list_from_file(dot_ns3rc_path, 'modules_enabled')
+    modules_enabled = get_list_from_file(dot_ns3rc_path, "modules_enabled")
     if not modules_enabled:
         # Enable all modules if the modules_enabled line can't be found.
-        modules_enabled = ['all_modules']
+        modules_enabled = ["all_modules"]
 
     # Read in whether examples should be enabled or not.
     value_if_missing = False
-    examples_enabled = get_bool_from_file(dot_ns3rc_path, 'examples_enabled', value_if_missing)
+    examples_enabled = get_bool_from_file(dot_ns3rc_path, "examples_enabled", value_if_missing)
 
     # Read in whether tests should be enabled or not.
     value_if_missing = False
-    tests_enabled = get_bool_from_file(dot_ns3rc_path, 'tests_enabled', value_if_missing)
+    tests_enabled = get_bool_from_file(dot_ns3rc_path, "tests_enabled", value_if_missing)
 
     return (config_file_exists, modules_enabled, examples_enabled, tests_enabled)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/VERSION ns-3.41/VERSION
--- ns-3.40/VERSION	2023-09-27 13:30:55.802883400 -0700
+++ ns-3.41/VERSION	2024-02-09 14:45:45.430484000 -0800
@@ -1 +1 @@
-3.40
+3.41
